<?php
include("inc_common.php");
include($engine_path."users_get_list.php");
set_variable("mesg");
set_variable("whisper");
set_variable("user_color");
set_variable("update_status");
set_variable("style_b");
set_variable("style_i");
set_variable("style_u");


if (!$exists) 
{
	$error_text = "$w_no_user";
	include($file_path."designes/".$design."/error_page.php");
	exit;
}
if (isset($update_status))
	if($update_status!="")
	{
		$update_status = intval($update_status);
		$fields_to_update[0][0] = 8;
		$fields_to_update[0][1] = $update_status;
		include($engine_path."user_din_data_update.php");
		header("location: session.php?session=$session&".time());
		exit;
	}

//functions
function addFaces($mesg)
{
	global $total_pics, $max_images, $chat_url;
	$l = 0;
	$temp = "";
	for ($i = 0; $i < strlen($mesg); $i++)
	{
		$oi = $i;
		$ok = 1;
		if (($mesg[$i] == ':' || $mesg[$i] == '=' || $mesg[$i] == ';')  and !(substr($mesg,$i-3,4)=="&lt;" or substr($mesg,$i-3,4)=="&gt;" or (substr($mesg,$i-5,1)=="&" &&$mesg[$i] == ';' ) ))
		{
			$alt = "";
			$brows = "normal";
			if ($i >= 4)
			{
				if ( substr($mesg,$i-4,4) == '&gt;')
				{
					$brows = "mad";
					$alt = "&gt;"; /*Orig: $alt = "]";*/
				}
				elseif ( substr($mesg,$i-4,4) == '&lt;')
				{
					$brows = "upset";
					$alt = "&lt;"; /*Orig = $alt="[";*/
				}
			}
			$prefix = "";
			if ($mesg[$i] == ';')
			{
				$prefix = "wink-";
				$alt .= ";";
			}
			else { $alt .= ":"; }
			$i++;
			if ($mesg[$i] == '^' || $mesg[$i] == '-' || $mesg[$i] == '\'')
			{  $i++;  $alt.="-";}
			$mouth = "";
			if ($mesg[$i] == ')' || $mesg[$i] == 'D' || $mesg[$i] == ']')
			{ $mouth = "smile"; $alt .= ")";}
			elseif ($mesg[$i] == '(')
			{ $mouth ="frown"; $alt .= "(";}
			elseif ($mesg[$i] == '|')
			{$mouth = "shy"; $alt .= "|";}
			elseif ($mesg[$i] == 'P' || $mesg[$i] == 'p' || $mesg[$i] == '' || $mesg[$i] == '')
			{$mouth = "tongue"; $alt .= "P";}
			elseif ($mesg[$i] == 'O' || $mesg[$i] == 'o' || $mesg[$i] == '' || $mesg[$i] == '')
			{$mouth = "amazed"; $alt .= "o";}
			if ($total_pics<$max_images)
			{
				if (strlen($mouth) != 0)
				{
					$ok = 0;
					$face = $prefix . $mouth . "-" . $brows;
					$face = "<img src=\"".$chat_url."faces/$face.gif\" alt=\"$alt\" width=16 height=16>";
					
					/*	      $temp[$l] = '\0'; */
					if (strcmp($brows, "normal") != 0)
					{ 
						$l = strlen ($temp) -4;
						$temp = substr($temp,0,$l); 
					}
					$temp .= $face;
					$total_pics++;
					$l = strlen($temp);
				}
				else
				{
					$i = $oi;
					$ok = 1;
				}
			}
			else {$ok = 1;$i = $oi;$l = strlen($temp);}
		}
		if ($ok == 1)
		{
			$temp .= $mesg[$i];
			$l++;
		}
	}
	return $temp;
}

function addURLS($str)
{
	global $chat_url;
	$str2 = $str;
	if (function_exists('preg_replace'))
	{
    	$str2 = preg_replace("/(?<!<a href=\")(?<!\")(?<!\">)((http|https|ftp):\/\/[\w?=&.\/-~#-_]+)/e",
				"'<a href=\"".$chat_url."go.php?url='.urlencode('\\1').'\" target=\"_blank\">\\1</a>'",
				$str);
	    $str2 = preg_replace("/((?<!<a href=\"mailto:)(?<!\">)(?<=(>|\s))[\w_-]+@[\w_.-]+[\w]+)/","<a href=\"mailto:\\1\">\\1</a>",$str2);
	}
	return $str2; 
}

function check_uppercase($mesg)
{
	global $max_cap_letters;
	if ($max_cap_letters)
	{
		$l = strlen($mesg);
		$t_u = 0;
		for ($i=0;$i<$l;$i++)
		{
			$ch = substr($mesg,$i,1);
			if ($ch == strtoupper($ch) && $ch != strtolower($ch))
			$t_u++;
		}
		if ($t_u > $max_cap_letters) $mesg = strtolower($mesg);
	}
	return $mesg;
}

function mesg2html($m_text)
{
	global $imgPhrase,$numOfImgPhrases,$mesg,$total_pics,$imgPhrase,$imgURL,$max_images;
	$m_text = addFaces(wordwrap($m_text, 75," ", 1));
	if ( substr_count($mesg,"**n") <7)
	{
		$m_text = str_replace("**n","<br>",$m_text);
	}
	$m_text = str_replace("<br><br>","<br>", $m_text);
	for ($j=0; $j<$numOfImgPhrases; $j++)
	{
		$total_pics+=substr_count($mesg,$imgPhrase[$j]);
		if ($max_images >= $total_pics)
			$m_text = str_replace($imgPhrase[$j], $imgURL[$j], $m_text);
	}
	return $m_text;
}

//end of functions


if ($user_color=="") {$user_color=$default_color;}
$user_color = intval($user_color);
if (($user_color < 0) or ($user_color >= count($registered_colors))) {$user_color=$default_color;}
SetCookie("c_user_color", $user_color, time() + 2678400);

$error_text = "";
$error = 0;
$total_pics = 0;
$messages_to_show = array();
if (!isset($mesg)){$mesg = "";}
$mesg = str_replace("\r"," ",str_replace("\n"," ",str_replace("\t"," ", $mesg)));




if ($mesg !="")
{
	$rndNumTest = "";
	if ($whisper != "")
	{
		for($i=0; $i<sizeof($users); $i++)
		{
			$data = explode("\t", $users[$i]);
			if ($data[0] == $whisper) 
			if($data[5] == 0) $rndNumTest=$data[1];
			else $rndNumTest = $whisper;
		}
			
		if ($rndNumTest == "")
		{
			$error_text .= $w_whisper_out."<br>\n";
			$error = 1;
		}
	}

	$converts = file($converts_file);
	$numOfImgPhrases = count($converts);
	for ($i=0;$i<$numOfImgPhrases;$i++) 
		if (strpos($converts[$i],"\t")) 
			list ($imgPhrase[$i], $imgURL[$i]) = explode("\t",trim($converts[$i]));
	
	//now it's in inc_common.php
	//if (get_magic_quotes_gpc()) $mesg = stripslashes($mesg);
	
	if (strlen($mesg)>512)  
	{
		$error_text .= $w_too_long."<br>\n"; 
		$error = 1;
	}
	
	if (!$error)
	{
		$mesg = " ".$mesg;
		$mesg = check_uppercase($mesg);
		$mesg = htmlspecialchars($mesg);
		$mesg = addURLS($mesg);
		$mesg_parts = array();
		$mesg_parts = split("<",$mesg);
		for ($i=0;$i<count($mesg_parts);$i++)
		{
			if ($i%2) 
			{
				list ($m_tag, $m_text) = split(">",$mesg_parts[$i]); 
				$mesg_parts[$i] = $m_tag.">".mesg2html($m_text);
			}
			else
			{
				$mesg_parts[$i] = mesg2html($mesg_parts[$i]);
			}
		}
		$mesg = implode("<",$mesg_parts);
		
		$mesg_prefix = ""; 
		$mesg_postfix = "";
		if($style_b != "" && $enabled_b_style) {
			$mesg_prefix .= "<b>";
			$mesg_postfix = "</b>".$mesg_postfix;
		}
		if($style_i != "" && $enabled_i_style) {
			$mesg_prefix .= "<i>";
			$mesg_postfix = "</i>".$mesg_postfix;
		}
		if($style_u != "" && $enabled_u_style) {
			$mesg_prefix .= "<u>";
			$mesg_postfix = "</u>".$mesg_postfix;
		}
		
		$t_color = $registered_colors[$user_color][1];
		$def_color = $registered_colors[$default_color][1];
		if (strpos($mesg, "/me ") == 1)
			$messages_to_show[] = array("time"=>my_time(), "room_id"=>$room_id, "from"=>"","to"=>"","body"=>"<font color=\"$def_color\">" .$mesg_prefix. $user_name." ". trim(substr($mesg, 5)) .$mesg_postfix. "</font>");
		else 
			$messages_to_show[] = array("time"=>my_time(), "room_id"=>$room_id,  "from"=>($colorize_nicks)?"<font color=\"$t_color\">$user_name</font>":$user_name, "to"=>$rndNumTest, "body"=>"<font color=\"$t_color\">".$mesg_prefix.trim($mesg).$mesg_postfix."</font>");
		$to_robot = strip_tags($mesg);
		$w_rob_name = $rooms[$room_id]["bot"];
		if (!$whisper) {
			include($ld_engine_path."robot_get_answers.php");
		}
		include($engine_path."messages_put.php");
		if ($mess_stat == 1 && !$error) {
			$fp = fopen($data_path."mess_stat.dat", "a+");
			flock($fp, LOCK_EX);
			fseek($fp,0);
			$normal_messages = intval(str_replace("\n","",@fgets($fp,1024)));
			$private_messages = intval(str_replace("\n","",@fgets($fp,1024)));
			if ($whisper)$private_messages++;
				else $normal_messages++;
			ftruncate($fp,0);
			fwrite($fp,$normal_messages."\n".$private_messages);
			fflush($fp);
			flock($fp, LOCK_UN);
			fclose($fp);
		}
	}
}

$out_users = array();
$who_j = 0;
for ($i=0;$i<count($users);$i++)
{
	list($who_nickname, $unused, $unused, $who_sex, $who_small_photo, $who_user_id, $unused, $unused, $who_status, $unused, $who_room,$unused, $unused, $unused)
		= explode("\t", $users[$i]);
	if ($who_room == $room_id)
	{
		$out_users[$who_j]["nickname"] = $who_nickname;
		$out_users[$who_j]["sex"] = $who_sex;
		$out_users[$who_j]["small_photo"] = $who_small_photo;
		$out_users[$who_j]["user_id"] = $who_user_id;
		$out_users[$who_j]["status"] = $who_status;
//		$out_users[$who_j]["room"] = $who_room;
		$who_j++;
	}
}
$total_users = count($out_users);



include($file_path."designes/".$design."/sender.php");
?>