<?php
if (!defined("_COMMON_")) {echo "stop";exit;}

function log_ban($admin, $to_ban, $ip_to_ban, $room, $reason) {
	global $data_path, $HTTP_SERVER_VARS;
	$REMOTE_ADDR = "";
	if (isset($HTTP_SERVER_VARS['REMOTE_ADDR'])) $REMOTE_ADDR = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	$fp_log = fopen($data_path."logs/".date("Y-m-d", my_time()).".log", "a+");
	flock($fp_log, LOCK_EX);
	fwrite($fp_log, date("H:i:s",my_time())."\t"."[BAN]\t".
			$REMOTE_ADDR ."\t".
			$admin."\troom ".$room."\t".
			$to_ban."(".$ip_to_ban.") ". $reason ."\n");
	fflush($fp_log);
	flock($fp_log, LOCK_UN);
	fclose($fp_log);
}

function log_unban($admin, $to_unban) {
	global $data_path, $HTTP_SERVER_VARS;
	$REMOTE_ADDR = "";
	if (isset($HTTP_SERVER_VARS['REMOTE_ADDR'])) $REMOTE_ADDR = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	$fp_log = fopen($data_path."logs/".date("Y-m-d", my_time()).".log", "a+");
	flock($fp_log, LOCK_EX);
	fwrite($fp_log, date("H:i:s",my_time())."\t"."[UNBAN]\t".
			$REMOTE_ADDR ."\t".
			$admin."\troom N/A\t".
			$to_unban."\n");
	fflush($fp_log);
	flock($fp_log, LOCK_UN);
	fclose($fp_log);
}

function log_message() {
	global $data_path, $messages_to_show, $HTTP_SERVER_VARS;
	$REMOTE_ADDR = "";
	if (isset($HTTP_SERVER_VARS['REMOTE_ADDR'])) $REMOTE_ADDR = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	$fp_log = fopen($data_path."logs/".date("Y-m-d", my_time()).".log", "a+");
	flock($fp_log, LOCK_EX);
	for ($i=0;$i<count($messages_to_show);$i++) 
		if ($messages_to_show[$i]["to"]=="")
			fwrite($fp_log, date("H:i:s",$messages_to_show[$i]["time"])."\t"."[MSG]\t".
				$REMOTE_ADDR ."\t".
				$messages_to_show[$i]["from"]."\troom ".$messages_to_show[$i]["room_id"]."\t".
				$messages_to_show[$i]["body"]."\n");
	fflush($fp_log);
	flock($fp_log, LOCK_UN);
	fclose($fp_log);
}
?>