<?php
if (!defined("_COMMON_")):
define("_COMMON_", 1);

error_reporting(E_ERROR|E_PARSE|E_CORE_ERROR|E_CORE_WARNING|E_COMPILE_ERROR|E_COMPILE_WARNING);
$debug = 0;

function my_err_h ($errno, $errstr, $errfile, $errline) {
	global $debug, $data_path,$file_path;
	switch($errno) {
		case E_NOTICE:
			if ($debug) echo "<b>NOTICE</b>: ".htmlspecialchars($errstr).",  at line ".$errline." in the file ".$errfile."<br>";
			else return 0;
		case E_WARNING:
			if ($debug) echo "<b>WARNING</b>: ".htmlspecialchars($errstr).",  at line ".$errline." in the file ".$errfile."<br>";
			else return 0;
		break;
		case E_USER_ERROR: 
			echo "<center><table border=\"0\"width=\"80%\" cellpadding=\"6\" cellspacing=\"0\">";
			echo "<tr><td bgcolor=\"red\" ><span style=\"color:white; font-weight: bold; font-size:18px; font-family: Arial, Verdana\">Voodoo chat -- Fatal error</span></td></tr>";
			
			echo "<tr bgcolor=\"#dddddd\"><td><span style=\"color:black; font-size:14px; font-family: Arial, Verdana\">We got the error <br><b>".htmlspecialchars($errstr)."</b><br>at line <b>".$errline."</b>";
			echo " in the file <b>".str_replace(dirname(dirname($errfile))."/", "", $errfile);
			echo "</span></td></tr>";
			echo "<tr bgcolor=\"#dddddd\"><td><span style=\"color:black; font-size:12px; font-family: Arial, Verdana\">";
			echo "Find help at <a href=\"http://voc.sf.net/\">Voodoo chat homepage</a>";
			echo "</td></tr>";
			echo "</table></center>";
			exit;
		break;
		case E_USER_WARNING: 
			echo "<center><table border=\"0\"width=\"80%\" cellpadding=\"6\" cellspacing=\"0\">";
			echo "<tr><td bgcolor=\"red\" ><span style=\"color:white; font-weight: bold; font-size:18px; font-family: Arial, Verdana\">Voodoo chat -- error</span></td></tr>";
			
			echo "<tr bgcolor=\"#dddddd\"><td><span style=\"color:black; font-size:14px; font-family: Arial, Verdana\">We got the error <br><b>".htmlspecialchars($errstr)."</b><br>at line <b>".$errline."</b>";
			echo " in the file <b>".str_replace(dirname(dirname($errfile))."/", "", $errfile);
			echo "</span></td></tr>";
			echo "<tr bgcolor=\"#dddddd\"><td><span style=\"color:black; font-size:12px; font-family: Arial, Verdana\">";
			echo "Find help at <a href=\"http://voc.sf.net/\">Voodoo chat homepage</a>";
			echo "</td></tr>";
			echo "</table></center>";
		break;
	}
	return 0;
}
set_error_handler("my_err_h");
// the path, where all data is stored  -- i.e. messages, user-boards etc. and also config file
// It is recommended to put this directory outside of your web-site access-path
$data_path = "/home/voodoo/www/voc/data/";

#loading parameters from config file

if (!($conf_content = implode("",file($data_path."voc.conf")))) {
	trigger_error("Cannot open voc.conf file, please check you DATA PATH parameter",E_USER_ERROR);
}
eval($conf_content);
#time-offset
function my_time()
{
	global $time_offset;
	return time()+$time_offset;
}

#for Register_gloabls = off
function set_variable($variable_name)
{
	global $HTTP_GET_VARS, $HTTP_POST_VARS, $HTTP_COOKIE_VARS, $$variable_name;
	$$variable_name = "";
	//GPC order :)
	if (isset($HTTP_GET_VARS[$variable_name])) $$variable_name = $HTTP_GET_VARS[$variable_name];
	if (isset($HTTP_POST_VARS[$variable_name])) $$variable_name = $HTTP_POST_VARS[$variable_name];
	if (substr($variable_name,0,2)=="c_" && isset($HTTP_COOKIE_VARS[$variable_name])) $$variable_name = $HTTP_COOKIE_VARS[$variable_name];
	if (get_magic_quotes_gpc() && is_string($$variable_name)) $$variable_name = stripslashes($$variable_name);
	//i don't use string-arrays in forms, so it's not neccessary to call stripslashes
}
set_variable("session");
set_variable("design");

#determening the current design
if ($design == "") $design = $default_design;
else if (!in_array($design, $designes)) $design = $default_design;
$current_design = $chat_url."designes/".$design."/";


#setting necessary variables
$daemon_url = $daemon_host.":".$daemon_port."/";
$engine_path = $data_path."engine/".$engine."/";
$ld_engine_path = $data_path."engine/".$long_life_data_engine."/";

$user_data_file = $data_path."users.dat";
$who_in_chat_file = $data_path."who.dat";
$messages_file = $data_path."messages.dat";
$converts_file = $data_path."converts.dat";
$robotspeak_file = $data_path."robotspeak.dat";
$banlist_file = $data_path."banlist.dat";
$rooms_list_file = $data_path."rooms.dat";

#user statuses
define('ONLINE',0);
define('DISCONNECTED',1);
define('AWAY',2);
define('NA',4);
define('DND',8);

#admin rights
define('ADM_BAN',1);
define('ADM_IP_BAN',2);
define('ADM_VIEW_IP',4);
define('ADM_UN_BAN',8);
define('ADM_BAN_MODERATORS',16);
define('ADM_CHANGE_TOPIC',32);
define('ADM_CREATE_ROOMS',64);
define('ADM_EDIT_USERS',128);
$total_admin_levels = 8;

#loading language pack
//require beacuse I need 'fatal error' if i cannot find the file
if(!defined("_VOC_CONFIG_")) {require_once($file_path."languages/".$language.".php");}
endif;
?>