<?php
if (!defined("_COMMON_")) {echo "stop";exit;}


function change_topic($room_id, $topic) {
	global $rooms_list_file;
	$fp = fopen($rooms_list_file, "a+");
	if (!flock($fp, LOCK_EX)) die ("can't lock file");
	fseek($fp,0);
	$to_write = "";
	while ($line = fgets($fp, 4096)) {
		$data = explode("\t",str_replace("\r","",str_replace("\n","",$line)));
		if ($data[0] == $room_id) $data[2] = $topic;
		$to_write .= implode("\t",$data) . "\n";
	}
	ftruncate($fp,0);
	fwrite($fp, $to_write);
	fflush($fp);
	flock($fp, LOCK_UN);
	fclose($fp);
}

function room_delete($room_id) {
	global $rooms_list_file;
	$fp = fopen($rooms_list_file, "a+");
	if (!flock($fp, LOCK_EX)) die ("can't lock file");
	fseek($fp,0);
	$to_write = "";
	while ($line = fgets($fp, 4096)) {
		$data = explode("\t",str_replace("\r","",str_replace("\n","",$line)));
		if ($data[0] != $room_id) $to_write .= implode("\t",$data) . "\n";
	}
	ftruncate($fp,0);
	fwrite($fp, $to_write);
	fflush($fp);
	flock($fp, LOCK_UN);
	fclose($fp);
}

function room_update($room_id,$name,$topic,$design,$bot) {
	global $rooms_list_file;
	$new_data = array ($name,$topic,$design,$bot);
	$fp = fopen($rooms_list_file, "a+");
	if (!flock($fp, LOCK_EX)) die ("can't lock file");
	fseek($fp,0);
	$to_write = "";
	while ($line = fgets($fp, 4096)) {
		$data = explode("\t",str_replace("\r","",str_replace("\n","",$line)));
		if ($data[0] == $room_id) $to_write .= $data[0]."\t".implode("\t",$new_data) . "\n";
		else $to_write .= implode("\t",$data) . "\n";
	}
	ftruncate($fp,0);
	fwrite($fp, $to_write);
	fflush($fp);
	flock($fp, LOCK_UN);
	fclose($fp);
}
function room_add($name,$topic,$design,$bot) {
	global $rooms_list_file;
	$new_data = array ($name,$topic,$design,$bot);
	$fp = fopen($rooms_list_file, "a+");
	if (!flock($fp, LOCK_EX)) die ("can't lock file");
	fseek($fp,0);
	$to_write = "";
	$last_id = 0;
	while ($line = fgets($fp, 4096)) {
		$data = explode("\t",str_replace("\r","",str_replace("\n","",$line)));
		if ($data[0] > $last_id) $last_id = $data[0];
		$to_write .= implode("\t",$data) . "\n";
	}
	$last_id++;
	$to_write .= $last_id."\t".implode("\t",$new_data) . "\n";
	ftruncate($fp,0);
	fwrite($fp, $to_write);
	fflush($fp);
	flock($fp, LOCK_UN);
	fclose($fp);
}

?>